import * as plugins from '../plugins.js';
import { WorkerEvent } from '../classes.workerevent.js';

export const rendertronResponder = async (cworkerevent: WorkerEvent) => {
  if (cworkerevent.routedThroughRendertron) {
    const oldHeaders: any = cworkerevent.request.headers;
    const rendertronHeaders = new Headers();
    for (const kv of oldHeaders.entries()) {
      const headerName = kv[0];
      const headerValue = headerName === 'user-agent' ? 'Lossless Rendertron' : kv[1];
      rendertronHeaders.append(headerName, headerValue);
    }
    const rendertronRequest = new Request(
      `https://rendertron.lossless.one/render/${cworkerevent.request.url}`,
      {
        method: cworkerevent.request.method,
        headers: rendertronHeaders
      }
    );
    cworkerevent.setResponse(await fetch(rendertronRequest));
  }
};
